import 'package:librus_api/account.dart';
import 'package:librus_api/models/category.dart';
import 'package:librus_api/models/grade.dart';
import 'package:librus_api/models/subject.dart';

Future<List<Subject>> fetchSubjects(Account account) async {
  List<Subject> subjects = await account.fetch<Subject>(() => Subject());
  List<Grade> grades = await account.fetch<Grade>(() => Grade());
  List<Category> categories = await account.fetch<Category>(() => Category());
  grades = account.bind<Grade, Subject>(grades, subjects, "subject");
  grades = account.bind<Grade, Category>(grades, categories, "category");
  grades.forEach((Grade grade) {
    subjects.forEach((Subject subject) {
      if (grade.subject == subject) {
        subject.grades.add(grade);
      }
    });
  });
  return subjects;
}
